import { ClauseInfo, DataSourceRule, Schema } from '../domain';
import { DataSourceConfigService } from './services/config/dataSourceConfigService';
import { MappingsConfigService } from './services/config/mappingsConfigService';
import { DomainConfigService } from './services/config/domainConfigService';
import { StageConfigService } from './services/config/stageConfigService';
import { ViewsConfigService } from './services/config/viewsConfigService';
import { RouteService } from './services/routeService';
import { SchemaExtender } from './services/schemaExtender';
import { SchemaService } from './services/schemaService';
import { CompleteSchema } from './useCases/complete';
import { GetSchema } from './useCases/get';
import { LoadSchema } from './useCases/load';
import { CreateSchema } from './useCases/create';
export declare class SchemaFacade {
    workspace: string;
    readonly source: DataSourceConfigService;
    readonly domain: DomainConfigService;
    readonly mapping: MappingsConfigService;
    readonly stage: StageConfigService;
    readonly view: ViewsConfigService;
    private readonly schemaService;
    private readonly routeService;
    private readonly extender;
    private readonly createSchema;
    private readonly loadSchema;
    private readonly getSchema;
    private readonly completeSchema;
    schema: Schema;
    constructor(workspace: string, source: DataSourceConfigService, domain: DomainConfigService, mapping: MappingsConfigService, stage: StageConfigService, view: ViewsConfigService, schemaService: SchemaService, routeService: RouteService, extender: SchemaExtender, createSchema: CreateSchema, loadSchema: LoadSchema, getSchema: GetSchema, completeSchema: CompleteSchema);
    evalDataSourceRule(rule: DataSourceRule, clauseInfo: ClauseInfo): boolean;
    getSource(clauseInfo: ClauseInfo, stage?: string): string;
    create(): Promise<Schema>;
    get(source: string): Promise<Schema | null>;
    initialize(source: string | Schema): Promise<Schema>;
    complete(schema: Schema): void;
}
