import { ModelConfig, MappingConfig } from '../../../schema/domain';
import { Query } from '../../../query/domain';
import { Helper } from '../../../shared/application';
import { SchemaFacade } from '../../../schema/application';
declare abstract class StageStateService<T> {
    protected readonly schemaFacade: SchemaFacade;
    protected readonly helper: Helper;
    constructor(schemaFacade: SchemaFacade, helper: Helper);
    get(name: string): Promise<T>;
    update(name: string, data: T): Promise<void>;
    remove(name: string): Promise<any>;
    protected abstract empty(): T;
    abstract getFile(name: string): any;
}
export declare class StageMappingService extends StageStateService<MappingConfig> {
    protected empty(): MappingConfig;
    getFile(name: string): any;
}
export declare class StageModelService extends StageStateService<ModelConfig> {
    protected empty(): ModelConfig;
    getFile(name: string): any;
    ddl(stage: string, action: string, queries: Query[]): Promise<void>;
    private ddlFile;
}
export {};
