"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-template-curly-in-string */
const __1 = require("../../..");
beforeAll(() => __awaiter(void 0, void 0, void 0, function* () {
    require('dotenv').config({ path: './config/countries.env' });
    yield __1.orm.init('./config/countries.yaml');
}));
describe('comparison', () => {
    const context = JSON.parse('{}');
    test('normalize', () => {
        expect(__1.orm.normalize('Countries.filter(p=> p.iso3 == "BRA").map(p=> p.name)')).toStrictEqual('Countries.map(p=>{name:p.name}).filter(p=>(p.iso3==BRA))');
        expect(__1.orm.normalize('Countries.filter(p=> p.iso3 === "BRA").map(p=> p.name)')).toStrictEqual('Countries.map(p=>{name:p.name}).filter(p=>(p.iso3==BRA))');
        expect(__1.orm.normalize('Countries.filter(p=> p.latitude < -9 && p.latitude > -11 && p.longitude == -55 ).first(p=> p.name)')).toStrictEqual('Countries.map(p=>{name:p.name}).filter(p=>((p.latitude<-9)&&((p.latitude>-11)&&(p.longitude==-55)))).sort(p=>asc(p.name)).page(1,1)');
        expect(__1.orm.normalize('Countries.filter(p=> between(p.latitude,-11,-9) && p.longitude == -55 ).first(p=> p.name)')).toStrictEqual('Countries.map(p=>{name:p.name}).filter(p=>(between(p.latitude,-11,-9)&&(p.longitude==-55))).sort(p=>asc(p.name)).page(1,1)');
        expect(__1.orm.normalize('Countries.filter(p=> in(p.iso3,["BRA","ARG"])).map(p=> p.name)')).toStrictEqual('Countries.map(p=>{name:p.name}).filter(p=>in(p.iso3,[BRA,ARG]))');
    });
    test('model', () => {
        expect(__1.orm.model('Countries.filter(p=> p.iso3 == "BRA").map(p=> p.name)')).toStrictEqual([{ 'name': 'name', 'type': 'string' }]);
        expect(__1.orm.model('Countries.filter(p=> p.iso3 === "BRA").map(p=> p.name)')).toStrictEqual([{ 'name': 'name', 'type': 'string' }]);
        expect(__1.orm.model('Countries.filter(p=> p.latitude < -9 && p.latitude > -11 && p.longitude == -55 ).first(p=> p.name)')).toStrictEqual([{ 'name': 'name', 'type': 'string' }]);
        expect(__1.orm.model('Countries.filter(p=> between(p.latitude,-11,-9) && p.longitude == -55 ).first(p=> p.name)')).toStrictEqual([{ 'name': 'name', 'type': 'string' }]);
        expect(__1.orm.model('Countries.filter(p=> in(p.iso3,["BRA","ARG"])).map(p=> p.name)')).toStrictEqual([{ 'name': 'name', 'type': 'string' }]);
    });
    test('parameters', () => {
        expect(__1.orm.parameters('Countries.filter(p=> p.iso3 == "BRA").map(p=> p.name)')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.filter(p=> p.iso3 === "BRA").map(p=> p.name)')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.filter(p=> p.latitude < -9 && p.latitude > -11 && p.longitude == -55 ).first(p=> p.name)')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.filter(p=> between(p.latitude,-11,-9) && p.longitude == -55 ).first(p=> p.name)')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.filter(p=> in(p.iso3,["BRA","ARG"])).map(p=> p.name)')).toStrictEqual([]);
    });
    test('constraints', () => {
        expect(__1.orm.constraints('Countries.filter(p=> p.iso3 == "BRA").map(p=> p.name)')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.filter(p=> p.iso3 === "BRA").map(p=> p.name)')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.filter(p=> p.latitude < -9 && p.latitude > -11 && p.longitude == -55 ).first(p=> p.name)')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.filter(p=> between(p.latitude,-11,-9) && p.longitude == -55 ).first(p=> p.name)')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.filter(p=> in(p.iso3,["BRA","ARG"])).map(p=> p.name)')).toStrictEqual({ "entity": "Countries", "constraints": [] });
    });
    test('getInfo', () => {
        expect(__1.orm.plan('Countries.filter(p=> p.iso3 == "BRA").map(p=> p.name)', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.name AS name FROM Countries c  WHERE c.iso3 = 'BRA' " });
        expect(__1.orm.plan('Countries.filter(p=> p.iso3 === "BRA").map(p=> p.name)', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.name AS name FROM Countries c  WHERE c.iso3 = 'BRA' " });
        expect(__1.orm.plan('Countries.filter(p=> p.latitude < -9 && p.latitude > -11 && p.longitude == -55 ).first(p=> p.name)', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.name AS name FROM Countries c  WHERE (c.latitude < -9 AND (c.latitude > -11 AND c.longitude = -55)) ORDER BY c.name asc  LIMIT 0,1 " });
        expect(__1.orm.plan('Countries.filter(p=> between(p.latitude,-11,-9) && p.longitude == -55 ).first(p=> p.name)', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.name AS name FROM Countries c  WHERE (c.latitude BETWEEN -11 AND -9 AND c.longitude = -55) ORDER BY c.name asc  LIMIT 0,1 " });
        expect(__1.orm.plan('Countries.filter(p=> in(p.iso3,["BRA","ARG"])).map(p=> p.name)', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.name AS name FROM Countries c  WHERE  c.iso3 IN ('BRA', 'ARG') " });
    });
});
//# sourceMappingURL=comparison.test.js.map